VERSION = 3.3

PROJET_BIN = ../../binary/sample-mingw$(VERSION).exe
PROJET_SRC = ../../sample
PROJET_INC = ../../sample
PROJET_OBJ = ../../build/mingw$(VERSION)

EXT_INC = -I ../../include
EXT_DIR = -L ../../library/mingw$(VERSION) 
EXT_LIB = -lmingw32 -mwindows -lwindow-wgl -lglew32s -lopengl32 -lglu32

CC = g++
OPTIMISATION = -Wall -pipe -O2 -fno-rtti -fno-exceptions

OBJ = \
	$(PROJET_OBJ)/sample.o

all: $(PROJET_BIN) clean

rep:
	mkdir $(PROJET_OBJ)

$(PROJET_BIN): $(OBJ)
	$(CC) -s -o $(PROJET_BIN) $^ $(EXT_DIR) $(EXT_LIB)

$(PROJET_OBJ)/%.o: $(PROJET_SRC)/%.cpp
	$(CC) -o $@ -c $< $(OPTIMISATION) $(EXT_INC)

clean:
	rm -R $(PROJET_OBJ)/*

